////////////////////////////////////////////////////////////////////////////////
///
/// CVmBackupTargetPreferences.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmBackupTargetPreferences.h"


CVmBackupTargetPreferences::CVmBackupTargetPreferences()
{
	InitLists();
	setDefaults();
}

CVmBackupTargetPreferences::CVmBackupTargetPreferences(const CVmBackupTargetPreferences& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmBackupTargetPreferences::CVmBackupTargetPreferences(const CVmBackupTargetPreferences* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmBackupTargetPreferences& CVmBackupTargetPreferences::operator=(const CVmBackupTargetPreferences& rObject)
{
	Copy(rObject);
	return *this;
}

CVmBackupTargetPreferences::CVmBackupTargetPreferences(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmBackupTargetPreferences::~CVmBackupTargetPreferences()
{
	ClearLists();
}


QString CVmBackupTargetPreferences::getDefaultBackupDirectory() const
{
	return m_qsDefaultBackupDirectory;
}

void CVmBackupTargetPreferences::setDefaultBackupDirectory(QString value)
{
	bool bValueChanged = (m_qsDefaultBackupDirectory != value);
	m_qsDefaultBackupDirectory = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalDefaultBackupDirectoryChanged(value);
	}
}

void CVmBackupTargetPreferences::slotChangeDefaultBackupDirectory(QString value)
{
	setDefaultBackupDirectory(value);
}

void CVmBackupTargetPreferences::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("DefaultBackupDirectory").isNull() )
		setDefaultBackupDirectory();
}

QVariant CVmBackupTargetPreferences::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "DefaultBackupDirectory.patch_stamp")
		value.setValue(getFieldPatchedValue("DefaultBackupDirectory"));

	if (path == "DefaultBackupDirectory")
		value.setValue(getDefaultBackupDirectory());

	return value;
}

bool CVmBackupTargetPreferences::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "DefaultBackupDirectory.patch_stamp")
	{
		markPatchedField("DefaultBackupDirectory", value.toString());
		return true;
	}

	if (path == "DefaultBackupDirectory")
	{
		if (pbValueChanged)
			*pbValueChanged = (getDefaultBackupDirectory() != value.value< QString >());
		setDefaultBackupDirectory(value.value< QString >());
		return true;
	}

	return false;
}

QString CVmBackupTargetPreferences::getDefaultBackupDirectory_id() const
{
	return getFullItemId().isEmpty() ? "DefaultBackupDirectory" : getFullItemId() + ".DefaultBackupDirectory";
}

int CVmBackupTargetPreferences::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool CVmBackupTargetPreferences::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement CVmBackupTargetPreferences::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("BackupTargetPreferences") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DefaultBackupDirectory");
	text_element = Document->createTextNode( QString("%1").arg(getDefaultBackupDirectory()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmBackupTargetPreferences::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (!eqName(tag_name, (ext_tag_name.isEmpty() ? QString("BackupTargetPreferences") : ext_tag_name), true))
	{
		m_qsErrorMessage = "Error in class 'CVmBackupTargetPreferences': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int DefaultBackupDirectory_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "DefaultBackupDirectory";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DefaultBackupDirectory_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (eqName(tag_name, "DefaultBackupDirectory"))
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDefaultBackupDirectory(text_element.data());
			--DefaultBackupDirectory_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (DefaultBackupDirectory_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmBackupTargetPreferences': tag 'DefaultBackupDirectory' is absent";
	}



	return 0;
}

void CVmBackupTargetPreferences::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool CVmBackupTargetPreferences::merge(CVmBackupTargetPreferences* pCur, CVmBackupTargetPreferences* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "BackupTargetPreferences";

	if (getDefaultBackupDirectory() != pCur->getDefaultBackupDirectory() && getDefaultBackupDirectory() == pPrev->getDefaultBackupDirectory())
		setDefaultBackupDirectory(pCur->getDefaultBackupDirectory());
	else if (getDefaultBackupDirectory() != pCur->getDefaultBackupDirectory() && getDefaultBackupDirectory() != pPrev->getDefaultBackupDirectory() && pCur->getDefaultBackupDirectory() != pPrev->getDefaultBackupDirectory())
	{
		m_qsErrorMessage += ".DefaultBackupDirectory";
		return false;
	}

	return true;
}

void CVmBackupTargetPreferences::diff(const CVmBackupTargetPreferences* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getDefaultBackupDirectory() != pOld->getDefaultBackupDirectory())
		lstDiffFullItemIds += getDefaultBackupDirectory_id();

}

void CVmBackupTargetPreferences::Copy(const CVmBackupTargetPreferences& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setDefaultBackupDirectory(rObject.getDefaultBackupDirectory());

	CustomCopy(&rObject);

}

void CVmBackupTargetPreferences::InitLists()
{
	CustomInit();
}

void CVmBackupTargetPreferences::ClearLists()
{
}

void CVmBackupTargetPreferences::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

