////////////////////////////////////////////////////////////////////////////////
///
/// CVmHardDisk.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMHARDDISK_H
#define CVMHARDDISK_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmMassStorageDevice.h"
#include "CVmHddPartition.h"
#include "CVmIoLimit.h"
#include "CVmHddEncryption.h"


class CVmHardDisk : public CVmMassStorageDevice
{
	Q_OBJECT

public:

	CVmHardDisk();
	CVmHardDisk(const CVmHardDisk& rObject);
	CVmHardDisk(const CVmHardDisk* pObject);
	CVmHardDisk(QFile* pFile);
	CVmHardDisk& operator=(const CVmHardDisk& rObject);
	virtual ~CVmHardDisk();


    PVE::HardDiskEmulatedType getEmulatedType() const { return (PVE::HardDiskEmulatedType )CVmDevice::getEmulatedType(); }

    virtual PRL_DEVICE_TYPE getDeviceType() const { return PDE_HARD_DISK; }

    virtual bool operator==( const CVmHardDisk& cVmHardDisk );

	QList<CVmHddPartition* >		m_lstPartition;
	QList<CVmIoLimit* >		m_lstIoLimit;
	QList<CVmHddEncryption* >		m_lstEncryption;

	CVmIoLimit* getIoLimit() const;
	void setIoLimit(CVmIoLimit* pIoLimit);

	CVmHddEncryption* getEncryption() const;
	void setEncryption(CVmHddEncryption* pEncryption);


	QString getUuid() const;
	void setUuid(QString value = QString());

	QString getMountPoint() const;
	void setMountPoint(QString value = QString());

	PRL_HARD_DISK_INTERNAL_FORMAT getDiskType() const;
	void setDiskType(PRL_HARD_DISK_INTERNAL_FORMAT value = PHD_EXPANDING_HARD_DISK);

	unsigned long getSize() const;
	void setSize(unsigned long value = (unsigned long )0);

	quint64 getSizeInBytes() const;
	void setSizeInBytes(quint64 value = 0);

	unsigned long getSizeOnDisk() const;
	void setSizeOnDisk(unsigned long value = (unsigned long )0);

	bool isSplitted() const;
	void setSplitted(bool value = false);

	PVE::HardDiskVersion getVersion() const;
	void setVersion(PVE::HardDiskVersion value = PVE::HardDiskV2);

	QString getCompatLevel() const;
	void setCompatLevel(QString value = QString());

	unsigned int getLogicalBlockSize() const;
	void setLogicalBlockSize(unsigned int value = 512);

	unsigned int getPhysicalBlockSize() const;
	void setPhysicalBlockSize(unsigned int value = 4096);

	bool isAutoCompressEnabled() const;
	void setAutoCompressEnabled(bool value = true);

	QUrl getStorageURL() const;
	void setStorageURL(QUrl value = QUrl());

	unsigned int getIopsLimit() const;
	void setIopsLimit(unsigned int value = 0);

	QString getSerialNumber() const;
	void setSerialNumber(QString value = QString());

	bool isRemovable() const;
	void setRemovable(bool value = false);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getUuid_id() const;
	QString getMountPoint_id() const;
	QString getIndex_id() const;
	QString getEnabled_id() const;
	QString getConnected_id() const;
	QString getEmulatedType_id() const;
	QString getSystemName_id() const;
	QString getUserFriendlyName_id() const;
	QString getRemote_id() const;
	QString getInterfaceType_id() const;
	QString getStackIndex_id() const;
	QString getDiskType_id() const;
	QString getSize_id() const;
	QString getSizeInBytes_id() const;
	QString getSizeOnDisk_id() const;
	QString getPassthrough_id() const;
	QString getSubType_id() const;
	QString getSplitted_id() const;
	QString getVersion_id() const;
	QString getCompatLevel_id() const;
	QString getDescription_id() const;
	QString getLogicalBlockSize_id() const;
	QString getPhysicalBlockSize_id() const;
	QString getAutoCompressEnabled_id() const;
	QString getStorageURL_id() const;
	QString getIopsLimit_id() const;
	QString getTargetDeviceName_id() const;
	QString getSerialNumber_id() const;
	QString getRemovable_id() const;
	QString getAlias_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmHardDisk* pCur, CVmHardDisk* pPrev, MergeOptions nOptions);

	void diff(const CVmHardDisk* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	QString		m_qsUuid;
	QString		m_qsMountPoint;
	PRL_HARD_DISK_INTERNAL_FORMAT		m_ctDiskType;
	unsigned long		m_ctSize;
	quint64		m_ctSizeInBytes;
	unsigned long		m_ctSizeOnDisk;
	bool		m_bSplitted;
	PVE::HardDiskVersion		m_ctDiskVersion;
	QString		m_qsCompatLevel;
	unsigned int		m_uiLogicalBlockSize;
	unsigned int		m_uiPhysicalBlockSize;
	bool		m_bAutoCompressEnabled;
	QUrl		m_urlStorageURL;
	unsigned int		m_uiIopsLimit;
	QString		m_qsSerialNumber;
	bool		m_bRemovable;

	void Copy(const CVmHardDisk& rObject);

signals:

	void signalUuidChanged(QString value, QString object_id = QString());
	void signalMountPointChanged(QString value, QString object_id = QString());
	void signalDiskTypeChanged(PRL_HARD_DISK_INTERNAL_FORMAT value, QString object_id = QString());
	void signalSizeChanged(unsigned long value, QString object_id = QString());
	void signalSizeInBytesChanged(quint64 value, QString object_id = QString());
	void signalSizeOnDiskChanged(unsigned long value, QString object_id = QString());
	void signalSplittedChanged(bool value, QString object_id = QString());
	void signalVersionChanged(PVE::HardDiskVersion value, QString object_id = QString());
	void signalCompatLevelChanged(QString value, QString object_id = QString());
	void signalLogicalBlockSizeChanged(unsigned int value, QString object_id = QString());
	void signalPhysicalBlockSizeChanged(unsigned int value, QString object_id = QString());
	void signalAutoCompressEnabledChanged(bool value, QString object_id = QString());
	void signalStorageURLChanged(QUrl value, QString object_id = QString());
	void signalIopsLimitChanged(unsigned int value, QString object_id = QString());
	void signalSerialNumberChanged(QString value, QString object_id = QString());
	void signalRemovableChanged(bool value, QString object_id = QString());

private slots:

	void slotChangeUuid(QString value);
	void slotChangeMountPoint(QString value);
	void slotChangeDiskType(PRL_HARD_DISK_INTERNAL_FORMAT value);
	void slotChangeSize(unsigned long value);
	void slotChangeSizeInBytes(quint64 value);
	void slotChangeSizeOnDisk(unsigned long value);
	void slotChangeSplitted(bool value);
	void slotChangeVersion(PVE::HardDiskVersion value);
	void slotChangeCompatLevel(QString value);
	void slotChangeLogicalBlockSize(unsigned int value);
	void slotChangePhysicalBlockSize(unsigned int value);
	void slotChangeAutoCompressEnabled(bool value);
	void slotChangeStorageURL(QUrl value);
	void slotChangeIopsLimit(unsigned int value);
	void slotChangeSerialNumber(QString value);
	void slotChangeRemovable(bool value);

};

#ifndef DM_3922657317
#define DM_3922657317
Q_DECLARE_METATYPE(PVE::DeviceEnabledState)
#endif
#ifndef DM_2134504477
#define DM_2134504477
Q_DECLARE_METATYPE(PVE::DeviceConnectedState)
#endif
#ifndef DM_4048696954
#define DM_4048696954
Q_DECLARE_METATYPE(PRL_MASS_STORAGE_INTERFACE_TYPE)
#endif
#ifndef DM_3570425462
#define DM_3570425462
Q_DECLARE_METATYPE(PRL_HARD_DISK_INTERNAL_FORMAT)
#endif
#ifndef DM_986472647
#define DM_986472647
Q_DECLARE_METATYPE(unsigned long)
#endif
#ifndef DM_658671433
#define DM_658671433
Q_DECLARE_METATYPE(quint64)
#endif
#ifndef DM_986472647
#define DM_986472647
Q_DECLARE_METATYPE(unsigned long)
#endif
#ifndef DM_1994420962
#define DM_1994420962
Q_DECLARE_METATYPE(PVE::DevicePassthroughMode)
#endif
#ifndef DM_3680791948
#define DM_3680791948
Q_DECLARE_METATYPE(PRL_CLUSTERED_DEVICE_SUBTYPE)
#endif
#ifndef DM_638538257
#define DM_638538257
Q_DECLARE_METATYPE(PVE::HardDiskVersion)
#endif


#endif
